题解 - 取数排列

题目描述

取1到N共N个连续的数字(1≤N≤9),组成每位数不重复的所有可能的N位数,按从小到大的顺序进行编号。当输入一个编号M时,就能打印出与该编号对应的那个N位数。例如,当N=3时,可组成的所有三位数为:

那么,输入编号M=2时,则输出132。

输入

包括两个数,即正整数N(1 <= N <= 9)和正整数M(1 <= M <= 362880)。

输出

只有一行,即与输入的编号M对应的那个N位数。

样例输入

3 2

样例输出 Copy

132

分析

N <= 9,所以可以直接将n全排列,时间复杂度为O(n!),9! = 362880,并且全排列的过程中是从1开始枚举到n,故满足从小到大的关系,即不需要再进行排序,总时间复杂度满足题目要求

全排列

cpp 复制代码
void dfs(int steps){
    if(steps == n + 1){
        tmp++; // tmp记录数量
        for(int i = 1;i <= n;i++) res[tmp][i] = path[i]; // res存储所有满足条件的情况
         
        return ;
    }
  
    for(int i = 1;i <= n;i++){
        if(!st[i]){
            st[i] = true;
            path[steps] = i;
            dfs(steps + 1);
            st[i] = false;
        }
    }
}

代码

cpp 复制代码
#include<bits/stdc++.h>
     
using namespace std;

const int N = 9 + 10,M = 362880 + 10;
 
int n,m;
int path[N];
bool st[N];
int tmp;
int res[M][N];
  
void dfs(int steps){
    if(steps == n + 1){
        tmp++;
        for(int i = 1;i <= n;i++) res[tmp][i] = path[i];
         
        return ;
    }
  
    for(int i = 1;i <= n;i++){
        if(!st[i]){
            st[i] = true;
            path[steps] = i;
            dfs(steps + 1);
            st[i] = false;
        }
    }
}
 
int main(){
    ios::sync_with_stdio;
    cin.tie(0),cout.tie(0);
 
    cin >> n >> m;
 
    dfs(1);
 
    for(int i = 1;i <= n;i++) cout << res[m][i];
 
    return 0;
}
相关推荐
海绵宝宝转agent2 分钟前
2026-10-9 leetcode100刷题+面经整理
笔记·算法·面试
yi01113 分钟前
DAY24: LeetCode 167:两数之和 II|从暴力枚举到左右双指针
笔记·python·算法·leetcode·二分查找·双指针
木井巳13 分钟前
【BFS 解决拓扑排序】课程表
java·算法·leetcode·广度优先·宽度优先·推荐算法·图搜索算法
扶风ff33 分钟前
练题簿在线免费刷题:会员线下组卷、Word 试卷与成绩导入,课堂检测更方便
java·开发语言·算法·小程序·word
程序员老陆37 分钟前
C++ 多线程通信方式全景:从共享内存到结构化协调
开发语言·c++
yi01141 分钟前
LeetCode 15:三数之和|排序 + 双指针,如何避免重复答案?
笔记·python·算法·leetcode·双指针
-dzk-1 小时前
【多维动态规划】LC 1143.最长公共子序列
算法·动态规划
某不知名網友1 小时前
ROS2 核心通信:话题发布与订阅详解
开发语言·c++
C++ 老炮儿的技术栈1 小时前
char (*csConnectName)[256]; 和 char csConnectName [256] 有什么区别
java·c语言·开发语言·c++·人工智能·算法·c
Omics Pro1 小时前
全新可重分析!代谢组质谱专用
数据库·人工智能·算法·机器学习·自然语言处理